#run.tcl  functions for manipulating the run number file

#set env(EXPERIMENTDIR) D:/laser
set filename run-parameters

#
# create and initialise run parameter file
#
proc parm-file-create {} {
	global env filename
	global chans dacstep dwell settle rampit
	global pulses

	set num 0

	set f [open $env(EXPERIMENTDIR)/$filename w]
	puts $f $num
	puts $f $chans
	puts $f $dacstep
	puts $f $dwell
	puts $f $settle
	puts $f $rampit
	puts $f $pulses
	close $f
	return 0
}
#
# read run number
#
proc run-num-read {} {
	global env filename

	set z [catch {open $env(EXPERIMENTDIR)/$filename r} f]
	if {$z!=0} then {return [parm-file-create]}

	set num [gets $f]
	close $f
	return $num
}
#
# increment run number and save parameters
#
proc run-num-incr-and-save {} {
	global env filename
	global chans dacstep dwell settle rampit
	global pulses

	set z [catch {open $env(EXPERIMENTDIR)/$filename r+} f]
	if {$z!=0} then {return [parm-file-create]}

	set num [gets $f]
#	set chans [gets $f]
#	set minv [gets $f]
#	set maxv [gets $f]
#	set dwell [gets $f]
#	set settle [gets $f]
	
	seek $f 0

	puts $f [incr num]
	puts $f $chans
	puts $f $dacstep
	puts $f $dwell
	puts $f $settle
	puts $f $rampit
	puts $f $pulses

	close $f
	return $num
}
#
# zero run number
#
proc run-num-zero {} {
	global env filename
#	global chans dacstep dwell settle rampit
	global pulses

	set z [catch {open $env(EXPERIMENTDIR)/$filename r+} f]
	if {$z!=0} then {return [parm-file-create]}

	set num [gets $f]
	set chans [gets $f]
	set dacstep [gets $f]
	set dwell [gets $f]
	set settle [gets $f]
	set rampit [gets $f]
	
	seek $f 0

	puts $f 0
	puts $f $chans
	puts $f $dacstep
	puts $f $dwell
	puts $f $settle
	puts $f $rampit
	puts $f $pulses

	close $f
	return $num
}
#
# read all parameters from file
#
proc parameters-restore {} {
	global env filename
	global chans dacstep dwell settle rampit
	global pulses

	set z [catch {open $env(EXPERIMENTDIR)/$filename r} f]
	if {$z!=0} then {return [parm-file-create]}

	set num [gets $f]
	set chans [gets $f]
	set dacstep [gets $f]
	set dwell [gets $f]
	set settle [gets $f]
	set rampit [gets $f]
	set pulses [gets $f]

	close $f
	return 0
}

#
# save all parameters to file
#
proc parameters-save {} {
	global env filename
	global chans dacstep dwell settle rampit
	global pulses

	set num [run-num-read]

	set f [open $env(EXPERIMENTDIR)/$filename w]
	puts $f $num
	puts $f $chans
	puts $f $dacstep
	puts $f $dwell
	puts $f $settle
	puts $f $rampit
	puts $f $pulses
	close $f
	return 0
}

